// AFRIKAANS - Delphi - With Dynamic Array
// Questions 3 & 5
// Please see marking guideline for mark breakdown

unit uRoete;

interface
  uses uStop, SysUtils;

  type StopSkikking = array of TStop;

  // V3.1  (3)
  type TRoete = class
    private
      roeteKode : char;
      isSirkel : boolean;
      stoppe : StopSkikking;

    public
      constructor Create(inRoeteKode : char; inIsSirkel : boolean);
      procedure stelStoppe(inStoppe : StopSkikking);
      function kryRoeteKode() : char;
      function kryStopBy(num : integer) : TStop;
      function toString() : string;
  end;

implementation
  // V3.2  (2)
  constructor TRoete.Create(inRoeteKode: Char; inIsSirkel: boolean);
  begin
    roeteKode := inRoeteKode;
    isSirkel := inIsSirkel;
  end;

  // V3.3  (2)
  procedure TRoete.stelStoppe(inStoppe : StopSkikking);
  begin
    stoppe := inStoppe;
  end;

  // V3.4  (1)
  function TRoete.kryRoeteKode() : char;
  begin
    Result := roeteKode;
  end;

  // V3.5  (5)
  function TRoete.kryStopBy(num: integer) : TStop;
  begin
    if (num >= 0) and (num < Length(stoppe)) then
    begin
      Result := stoppe[num]
    end
    else
    begin
      Result := nil
    end;
    // aanvaar ook indien argument by 1 begin solank gleufverwerking
    // korrek is en V7.1 ook ooreenstem
    {
      if (num >= 1) and (num <= Length(stoppe)) then
      begin
        Result := stoppe[num-1]
      end
      else
      begin
        Result := nil
      end;
    }
  end;

  // V5  (9)
  function TRoete.toString() : string;
  var
    i : integer;
  begin
    Result := roeteKode + ' - ';

    if Length(stoppe) = 0 then         // aanvaar ook <= 0
    begin
      Result := Result + 'Ongeldig';
    end
    else
    begin


      if (isSirkel) then
      begin
        Result := Result + 'Sirkel';
      end
      else
      begin
        Result := Result + 'Liner';
      end;

      for i:= 0 to Length(stoppe)-1 do
      begin
        Result := Result + #13#10 + '-> ' + IntToStr(i+1)
                + #9 + stoppe[i].toString();
      end;




      if (isSirkel) then
      begin
        Result := Result + #13#10 + '-> 1' + #9 + stoppe[0].toString();
      end
      else
      begin
        for i:= Length(stoppe)-2 downto 0 do
        begin
          Result := Result + #13#10 + '-> ' + IntToStr(i+1) + #9
  + stoppe[i].toString();
        end;
      end;
    end;
  end;
end.

