// AFRIKAANS - Delphi - With Dynamic Array
// Questions 4 and 7
// Please see marking guideline for mark breakdown

unit uToerBestuurder;

interface
 uses uStop, uRoete, SysUtils;

  // V4.1  (1)
  type TStopBestuurder = class

    // V4.2  (3)
    private
      alleStoppe : array[1..100] of TStop;
      stopCount : integer;
    public
      constructor Create(inFilename : string);
      function kryRoeteMetKode(inKode:char; inIsSirkel:boolean):TRoete;
      function werkStopPunteUit(r1, r2 : TRoete) : string;
  end;

implementation
  // V4.3  (9)
  constructor TStopBestuurder.Create(inFilename : string);
  var
    inFile : TextFile;
    line, sNaam, rKodes: string;
    sTipe: integer;
  begin
    AssignFile(inFile, inFilename);
    Reset(inFile);

    while NOT EOF(infile) do
    begin
      Readln(inFile, line);

      sNaam := Copy(line, 1, Pos(',', line) -1 );
      Delete(line, 1, Pos(',', line));

      sTipe := StrToInt(Copy(line, 1, Pos(',', line) -1 ));
      Delete(line, 1, Pos(',', line));
      rKodes := line;

      Inc(stopCount);
      alleStoppe[stopCount] := TStop.Create(sNaam, rKodes, sTipe);
    end;
  end;

  // V4.4  (10)
  function TStopBestuurder.kryRoeteMetKode(inKode: char ;
                      inIsSirkel : boolean) : TRoete;
  var
    count, i : integer;
    tStoppe : StopSkikking;
  begin
    Result := TRoete.Create(inKode, inIsSirkel);




    count := 0;
    setLength(tStoppe, 0);
    setLength(tStoppe, 100);

    for i := 1 to stopCount do
    begin
      if (alleStoppe[i].isDeelVanRoete(inKode)) then
      begin
        tStoppe[count] := alleStoppe[i];
        inc(count);
      end;
    end;

    setLength(tStoppe, count);


    Result.stelStoppe(tStoppe);
  end;


  // V7.1  (6)
  function TStopBestuurder.werkStopPunteUit(r1, r2 : TRoete) : string;

  // Punte toegeken volgens doelwitte bereik:
       // 1  O1: lus om deur roete 1-stoppe te gaan
       // 1  O2: toets of dit ook aan roete 2 behoort
       // 1  O3: doeltreffendheid  geen herlees van ler, geen ander metode geskep nie
       // 1  O4: stringaaneenskakeling korrek gedoen
       // 1  O5: korrekte terugsending (0 indien daar terugsending is maar nie korrek nie)

  var
    // vir alternatief 1
    count : integer;
    // vir alternatief 2
    i :integer;
  begin
    Result := '';
    // alternatief 1: werk met die twee Roete-objekte

    count := 0;

    while (r1.kryStopBy(count) <> nil) do
    begin
      if r1.kryStopBy(count).isDeelVanRoete(r2.kryRoeteKode()) then
      begin
          Result := Result + r1.kryStopBy(count).toString() + #13#10;
      end;
      inc(count);
    end;


    // alternatief 2: werk met die alleStoppe-skikking
    {
    for i := 1 to stopCount do
    begin

      if (alleStoppe[i].isDeelVanRoete(r1.kryRoeteKode()))
          and
         (alleStoppe[i].isDeelVanRoete(r2.kryRoeteKode())) then
      begin
         Result := Result + alleStoppe[i].toString() + #13#10;
      end;
    end;
    }
  end;
end.

