// AFRIKAANS - Delphi - With Static Array
// Questions 3 & 5
// Please see marking guideline for mark breakdown

unit uRoete;

interface
  uses uStop, SysUtils;

  // V3.1  (3)
  type StopSkikking = array[1..100] of TStop;

  type TRoete = class
    private
      roeteKode : char;
      isSirkel : boolean;
      stoppe : StopSkikking;
      numStopsFound : integer;  // needed for Q3.5
    public
      constructor Create(inRoeteKode : char; inIsSirkel : boolean);
      procedure stelStoppe(inStoppe : StopSkikking);
      function kryRoeteKode() : char;
      function kryStopBy(num : integer) : TStop;
      function toString() : string;
  end;

implementation
  // V3.2  (2)
  constructor TRoete.Create(inRoeteKode: Char; inIsSirkel: boolean);
  begin
    roeteKode := inRoeteKode;
    isSirkel := inIsSirkel;
  end;

  // V3.3  (2)
  procedure TRoete.stelStoppe(inStoppe : StopSkikking);
  var
    i : integer;
  begin
    stoppe := inStoppe;
	numStopsFound := 0;

    for i := 1 to 100 do
    begin
      if stoppe[i] <> nil then
      begin
        Inc(numStopsFound);
      end
    end
  end;

  // V3.4  (1)
  function TRoete.kryRoeteKode() : char;
  begin
    Result := roeteKode;
  end;

  // V3.5  (5)
  function TRoete.kryStopBy(num: integer) : TStop;
  begin
    if (num >= 1) and (num <= numStopsFound) then
    begin
      Result := stoppe[num]
    end
    else
    begin
      Result := nil
    end;
  end;

  
  // V5  (9)
  function TRoete.toString() : string;
  var
    i : integer;
  begin
    Result := roeteKode + ' - ';

    if Length(stoppe) = 0 then         // aanvaar ook <= 0
    begin
      Result := Result + 'Ongeldig';
    end
    else
    begin
      if (isSirkel) then
      begin
        Result := Result + 'Sirkel';
      end
      else
      begin
        Result := Result + 'Liner';
      end;

      for i:= 1 to numStopsFound do
      begin
        Result := Result + #13#10 + '-> ' + IntToStr(i) + #9 + stoppe[i].toString();
      end;

      if (isSirkel) then
      begin
        Result := Result + #13#10 + '-> 1' + #9 + stoppe[1].toString();
      end
      else
      begin
        for i:= numStopsFound-1 downto 1 do
        begin
          Result := Result + #13#10 + '-> ' + IntToStr(i) + #9 + stoppe[i].toString();
        end;
      end;
    end;
  end;
end.