// AFRIKAANS - Delphi - With Static Array
// Question 2
// Please see marking guideline for mark breakdown

unit uStop;

interface
  uses SysUtils;

  // V2.1 - (1)
  type TStop = class

    // V2.2  (3)
    private
      stopNaam : string;
      roeteKodes : string;
      stopTipe : integer;

    // V2.3  (3)
    public
      const
        STOPTIPE_KAFEE = 1;
        STOPTIPE_SKUILING = 2;
        STOPTIPE_SNEL = 3;
        STOPTIPE_ANDER = 4;

      constructor Create(inStopNaam , inRoeteKodes : string; inStopTipe : integer);
      function kryStopTipeNaam() : string  ;
      function isDeelVanRoete(r: char) : boolean;
      function toString() : string;
  end;

implementation
   // V2.4  (7)
   constructor TStop.Create(inStopNaam , inRoeteKodes : string; inStopTipe : integer);
   begin
     stopNaam := inStopNaam;
     roeteKodes := inRoeteKodes;

     if (inStopTipe = STOPTIPE_KAFEE) or
         (inStopTipe = STOPTIPE_SKUILING) or
         (inStopTipe = STOPTIPE_SNEL) then
     begin
       stopTipe := inStopTipe;
     end
     else
     begin
       stopTipe := STOPTIPE_ANDER
     end;
   end;


   // V2.5  (3)
   function TStop.kryStopTipeNaam() : string ;
   begin
    case stopTipe of   
      STOPTIPE_KAFEE : Result := 'kafee';
      STOPTIPE_SNEL : Result := 'snel';
      STOPTIPE_SKUILING : Result := 'skuiling';
      else Result := 'ander';
    end;
   end;


   // V2.6  (3)
   function TStop.isDeelVanRoete(r: char) : boolean;
   begin
     Result := Pos(r, roeteKodes) > 0;

     // gebruik if-stelling
     {
	 if Pos(r, roeteKodes) > 0 then
     begin
        Result := true
     end
     else
     begin
        Result := false
     end;
	 }
   end;


   // V2.7  (3)
   function TStop.toString() : string;
   begin
     Result := kryStopTipeNaam() + #9 + stopNaam
   end;

end.