// ENGLISH - Delphi - With Dynamic Array
// Questions 3 & 5
// Please see marking guideline for mark breakdown

unit uRoute;

interface
  uses uStop, SysUtils;

  // Q3.1 - 3 Marks
  type StopArray = array of TStop;

  type TRoute = class
    private
      routeCode : char;
      isCircular : boolean;
      stops : StopArray;

    public
      constructor Create(inRouteCode : char; inIsCircular : boolean);
      procedure setStops(inStops : StopArray);
      function getRouteCode() : char;
      function getStopAt(num : integer) : TStop;
      function toString() : string;
  end;
  
implementation
  // Q3.2 - 2 Marks
  constructor TRoute.Create(inRouteCode: Char; inIsCircular: boolean);
  begin
    routeCode := inRouteCode;
    isCircular := inIsCircular;
  end;

  // Q3.3 - 2 Marks
  procedure TRoute.setStops(inStops : StopArray);
  begin
    stops := inStops;
  end;

  // Q3.4 - 1 Mark
  function TRoute.getRouteCode() : char;
  begin
    Result := routeCode;
  end;

  // Q3.5 - 5 Marks
  function TRoute.getStopAt(num: integer) : TStop;
  begin
    if (num >= 0) and (num <= Length(stops)) then
    begin
      Result := stops[num]
    end
    else
    begin
      Result := nil
    end;
    // also accept if argument starts from 1 as long as slot    
    //processing is correct and Q7.1 also matches
    {
      if (num >= 1) and (num <= Length(stops)) then
      begin
        Result := stops[num-1]
      end
      else
      begin
        Result := nil
      end;
    }
  end;

  // Q5 - 9 Marks
  function TRoute.toString() : string;
  var
    i : integer;
  begin
    Result := routeCode + ' - ';

    if Length(stops) = 0 then  // also accept <= 0
    begin
      Result := Result + 'Invalid';
    end
    else
    begin
      if (isCircular) then
      begin
        Result := Result + 'Circular';
      end
      else
      begin
        Result := Result + 'Linear';
      end;

      for i:= 0 to Length(stops)-1 do
      begin
        Result := Result + #13#10 + '-> ' + IntToStr(i+1) + #9 + stops[i].toString();
      end;

      if (isCircular) then
      begin
        Result := Result + #13#10 + '-> 1' + #9 + stops[0].toString();
      end
      else
      begin
        for i:= Length(stops)-2 downto 0 do
        begin
          Result := Result + #13#10 + '-> ' + IntToStr(i+1) + #9 + stops[i].toString();
        end;
      end;
    end;
  end;
  
end.