// ENGLISH - Delphi - With Static Array
// Questions 3 & 5
// Please see marking guideline for mark breakdown

unit uRoute;

interface
  uses uStop, SysUtils;

  // Q3.1 - 3 Marks
  type StopArray = array[1..100] of TStop;

  type TRoute = class
    private
      routeCode : char;
      isCircular : boolean;
      stops : StopArray;
      numStopsFound : integer;  // needed for Q3.5
    public
      constructor Create(inRouteCode : char; inIsCircular : boolean);
      procedure setStops(inStops : StopArray);
      function getRouteCode() : char;
      function getStopAt(num : integer) : TStop;
      function toString() : string;
  end;
implementation

  // Q3.2 - 2 Marks
  constructor TRoute.Create(inRouteCode: Char; inIsCircular: boolean);
  begin
    routeCode := inRouteCode;
    isCircular := inIsCircular;
  end;

  // Q3.3 - 2 Marks
  procedure TRoute.setStops(inStops : StopArray);
  var
    i : integer;
  begin
    stops := inStops;
    numStopsFound := 0;

    for i := 1 to 100 do
    begin
      if stops[i] <> nil then
      begin
        Inc(numStopsFound);
      end
    end
  end;

  // Q3.4 - 1 Mark
  function TRoute.getRouteCode() : char;
  begin
    Result := routeCode;
  end;

  // Q3.5 - 5 Marks
  function TRoute.getStopAt(num: integer) : TStop;
  begin
    if (num >= 1) and (num <= numStopsFound) then
    begin
      Result := stops[num]
    end
    else
    begin
      Result := nil
    end;
  end;


  // Q5 - 9 Marks
  function TRoute.toString() : string;
  var
    i : integer;
  begin
    Result := routeCode + ' - ';

    if numStopsFound = 0 then
    begin
      Result := Result + 'Invalid';
    end
    else
    begin
      if (isCircular) then
      begin
        Result := Result + 'Circular';
      end
      else
      begin
        Result := Result + 'Linear';
      end;

      for i:= 1 to numStopsFound do
      begin
        Result := Result + #13#10 + '-> ' + IntToStr(i) + #9 + stops[i].toString();
      end;

      if (isCircular) then
      begin
        Result := Result + #13#10 + '-> 1' + #9 + stops[1].toString();

      end
      else
      begin
        for i:= numStopsFound-1 downto 1 do
        begin
            Result := Result + #13#10 + '-> ' + IntToStr(i) + #9 + stops[i].toString();
        end
      end;
    end;
  end;
end.
