// ENGLISH - Delphi - With Static Array
// Questions 4 and 7
// Please see marking guideline for mark breakdown

unit uTourManager;

interface
 uses uStop, uRoute, SysUtils;

  // Q4.1 - 1 Mark
  type TStopManager = class
  
    // Q4.2 - 3 Marks
    private
      allStops : array[1..100] of TStop;
      stopCount : integer;
    public
      constructor Create(inFilename : string);
      function getRouteWithCode(inCode : char ; inIsCircular : boolean) : TRoute;
      function workOutStopPoints(r1, r2 : TRoute) : string;
  end;

implementation
  // Q 4.3 - 9 Marks
  constructor TStopManager.Create(inFilename : string);
  var
    inFile : TextFile;
    line, tStopName, tRouteCodes : string;
    tStopType : integer;
  begin
    AssignFile(inFile, inFilename);
    Reset(inFile);

    while NOT EOF(infile) do
    begin
      Readln(inFile, line);

      tStopName := Copy(line, 1, Pos(',', line) -1 );
      Delete(line, 1, Pos(',', line));

      tStopType := StrToInt(Copy(line, 1, Pos(',', line) -1 ));
      Delete(line, 1, Pos(',', line));
      tRouteCodes := line;

      Inc(stopCount);
      allStops[stopCount] := TStop.Create(tStopName, tRouteCodes, tStopType);
    end;
  end;

  // Q4.4 - 10 Makrs
  function TStopManager.getRouteWithCode(inCode : char ; inIsCircular : boolean) : TRoute;
  var
    count, i : integer;
    tStops : StopArray;
  begin
    Result := TRoute.Create(inCode, inIsCircular);

    count := 1;
    for i := 1 to 100 do
    begin
      tStops[i] := nil;
    end;

    for i := 1 to stopCount do
    begin
      if (allStops[i].isPartOfRoute(inCode)) then
      begin
        tStops[count] := allStops[i];
        inc(count);
      end;
    end;

    Result.setStops(tStops);
  end;

  
  // Q7.1 - 6 Marks
  function TStopManager.workOutStopPoints(r1, r2 : TRoute) : string;
  var
    // for alternative 1
    count : integer;
    // for alternative 2
    i :integer;
  begin
    Result := '';
    // alternative 1 working with the two route objects
    {
    count := 1;

    while (r1.getStopAt(count) <> nil) do
    begin
      if r1.getStopAt(count).isPartOfRoute(r2.getRouteCode()) then
      begin
          Result := Result + r1.getStopAt(count).toString() + #13#10;
      end;
      inc(count);
    end;
    }

    // alternative 2 working with the allstops array
    //{
    for i := 1 to stopCount do
    begin
      if (allStops[i].isPartOfRoute(r1.getRouteCode())) and
         (allStops[i].isPartOfRoute(r2.getRouteCode())) then
      begin
         Result := Result + allStops[i].toString() + #13#10;
      end;
    end;
    //}
  end;
end.